#include <stdio.h>
#include <stdlib.h>
#include "../table.h"

struct record {
	char *a; // defined in schema as VARCHAR(43)
	char *b; // defined in schema as VARCHAR(23)
	int c;
	int d;
};

int main(int argc, char **argv) {
	FILE *stream;
	struct table_handler *table;

	printf("reading schema\n");
	if (!(stream = fopen("schema.txt", "rb"))) {
		perror("ikaldus");
		exit(-1);
	}
	printf("creating table\n");
	if (create_table(stream) == -1) {
		show_error();
		exit(EXIT_FAILURE);
	}
	printf("opening database\n");
	if (!(table = open_datafile("kalamaja00"))) {
		show_error();
		exit(EXIT_FAILURE);
	}	
#ifdef DEBUG
	show_schema(table);
#endif
	insert_known_data(table);
	printf("closing database\n");
	close_datafile(table);
	printf("opening database\n");
	table = open_datafile("kalamaja00");
	read_back_known_data(table);
	printf("closing database\n");
	close_datafile(table);
}

int insert_known_data(struct table_handler *table) {
	/* this inserts some records with known values into table, useful for debugging */
	struct record tmp = { "tere", "kala", 1, 42 };
	struct record tmp2 = { "tere2", "kala2", 2, 43 };
	struct record tmp3 = { "tere01", "kala01", 3, 44 };

	/* this should work unless you find yourself some compiler that packs structs in some arcane way */
	printf("inserting  data\n");
	add_rec(table, (void*)&tmp);
	printf("\t%s\t%s\t%d\t%d\n", tmp.a, tmp.b, tmp.c, tmp.d);
	add_rec(table, (void*)&tmp2);
	printf("\t%s\t%s\t%d\t%d\n", tmp2.a, tmp2.b, tmp2.c, tmp2.d);
	add_rec(table, (void*)&tmp3);
	printf("\t%s\t%s\t%d\t%d\n", tmp3.a, tmp3.b, tmp3.c, tmp3.d);
}	

int read_back_known_data(struct table_handler *table) {
	struct record *tmp = NULL;
	register int i;
	
	printf("reading from database\n");
	for (i=0; i<3; i++) {
		read_next((void**)&tmp, table);
#ifdef DEBUG
		printf("pointer to tester: %ld\n", tmp);
#endif
		printf("\t%s\t%s\t%d\t%d\n", tmp->a, tmp->b, tmp->c, tmp->d);
		free(tmp->a);
		free(tmp->b);
		free(tmp);
	}
}
